local s=require'iwinfo'
local e=require("simple-uci").cursor()
local c=require'gluon.site'
local i=require'gluon.wireless'
local function u(e)
local o=s.nl80211.txpwrlist(e)or{}
local e=tonumber(s.nl80211.txpower_offset(e))or 0
local t={}
local a=-1
for o,i in ipairs(o)do
local o=i.dbm+e
local e=math.floor(10^(o/10))
if e~=a then
a=e
table.insert(t,{
display_dbm=o,
display_mw=e,
driver_dbm=i.dbm,
})
end
end
return t
end
local a=Form(translate("WLAN"))
a:section(Section,nil,translate(
"You can enable or disable your node's client and mesh network "
.."SSIDs here. Please don't disable the mesh network without "
.."a good reason, so other nodes can mesh with yours.<br><br>"
.."It is also possible to configure the WLAN adapters transmission power "
.."here. Please note that the transmission power values include the antenna gain "
.."where available, but there are many devices for which the gain is unavailable or inaccurate."
))
local r={}
e:foreach('wireless','wifi-device',function(o)
local t=o['.name']
local h=false
local n
if o.band=='2g'then
n=translate("2.4GHz WLAN")
elseif o.band=='5g'then
h=true
n=translate("5GHz WLAN")
else
return
end
local s=a:section(Section,n)
local function l(a)
local o={}
for i,a in ipairs(a)do
if e:get('wireless',a..'_'..t)then
table.insert(o,a)
end
end
return o
end
local function d(a)
for o,a in ipairs(a)do
if not e:get_bool('wireless',a..'_'..t,'disabled')then
return true
end
end
return false
end
local function n(i,a,h)
local o=l(a)
if#o==0 then
return
end
local a=s:option(Flag,t..'_'..i..'_enabled',h)
a.default=d(o)
function a:write(i)
for o,a in ipairs(o)do
e:set('wireless',a..'_'..t,'disabled',not i)
end
end
return a
end
n('client',{'client','owe'},translate('Enable client network (access point)'))
local a=n('mesh',{'mesh'},translate("Enable mesh network (802.11s)"))
if h then
table.insert(r,a)
end
local a=i.find_phy(o)
if not a then
return
end
local o=u(a)
if#o<=1 then
return
end
local a=s:option(ListValue,t..'_txpower',translate("Transmission power"))
a.default=e:get('wireless',t,'txpower')or'default'
a:value('default',translate("(default)"))
table.sort(o,function(e,t)return e.driver_dbm>t.driver_dbm end)
for t,e in ipairs(o)do
a:value(e.driver_dbm,string.format("%i dBm (%i mW)",e.display_dbm,e.display_mw))
end
function a:write(a)
if a=='default'then
a=nil
end
e:set('wireless',t,'txpower',a)
end
end)
if i.device_uses_11a(e)and not i.preserve_channels(e)then
local a=a:section(Section,translate("Outdoor Installation"),translate(
"Configuring the node for outdoor use tunes the 5 GHz radio to a frequency "
.."and transmission power that conforms with the local regulatory requirements. "
.."It also enables dynamic frequency selection (DFS; radar detection). At the "
.."same time, mesh functionality is disabled as it requires neighbouring nodes "
.."to stay on the same channel permanently."
))
local t=a:option(Flag,'outdoor',translate("Node will be installed outdoors"))
t.default=e:get_bool('gluon','wireless','outdoor')
for a,e in ipairs(r)do
e:depends(t,false)
if t.default then
e.default=not c.wifi5.mesh.disabled(false)
end
end
function t:write(t)
e:set('gluon','wireless','outdoor',t)
end
e:foreach('wireless','wifi-device',function(n)
local o=n['.name']
local h=e:get('wireless',o,'band')
if h~='5g'then
return
end
local i=i.find_phy(n)
local a=a:option(ListValue,'outdoor_htmode',translate('HT Mode')..' ('..o..')')
a:depends(t,true)
a.default=e:get('gluon','wireless','outdoor_'..o..'_htmode')or'default'
a:value('default',translate("(default)"))
for e,t in pairs(s.nl80211.htmodelist(i))do
if t then
a:value(e,e)
end
end
function a:write(t)
if t=='default'then
t=nil
end
e:set('gluon','wireless','outdoor_'..o..'_htmode',t)
end
end)
end
function a:write()
e:commit('gluon')
os.execute('/lib/gluon/upgrade/200-wireless')
e:commit('network')
e:commit('wireless')
end
return a
